package org.gatein.examples.jcr;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jcr.RepositoryException;
import javax.portlet.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.exoplatform.services.jcr.config.RepositoryConfigurationException;
import org.gatein.examples.jcr.processor.JcrProcessor;

/**
 * JCR perf Portlet Class
 */
public class JCRPortlet extends GenericPortlet {

    private static final Log log = LogFactory.getLog(JCRPortlet.class);
    // true = read
    // false = write
    private boolean mode;
    
    @Override
	public void init() throws PortletException {
		super.init();
		mode = Boolean.valueOf(getPortletConfig().getInitParameter("mode"));
	}

	public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
        response.setContentType("text/html");
        JcrProcessor jcrProc = new JcrProcessor();
        log.debug(jcrProc.c);
        try {
            jcrProc.connectRepository("portal-system");
            if (mode) {
                jcrProc.accessNNodes(jcrProc.getRootNode(), 50);
            } else {
                for (int i = 0; i < 10; i++) {
                    jcrProc.addRandomNode(jcrProc.getRootNode());
                }
            }
        } catch (RepositoryException ex) {
            Logger.getLogger(JCRPortlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (RepositoryConfigurationException ex) {
            Logger.getLogger(JCRPortlet.class.getName()).log(Level.SEVERE, null, ex);
        }
        log.debug(jcrProc.c);
        request.setAttribute("mode", mode ? "read" : "write");
        PortletRequestDispatcher dispatcher = getPortletContext().getRequestDispatcher("/WEB-INF/jsp/view.jsp");
        dispatcher.include(request, response);
    }
}
