/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gatein.examples.jcr.processor;

import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jcr.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.jcr.RepositoryService;
import org.exoplatform.services.jcr.config.RepositoryConfigurationException;
import org.exoplatform.services.jcr.core.ManageableRepository;
import org.exoplatform.services.jcr.ext.app.SessionProviderService;
import org.exoplatform.services.jcr.ext.common.SessionProvider;

/**
 *
 * @author vrockai
 */
public class JcrProcessor {

    private static final Log log = LogFactory.getLog(JcrProcessor.class);
    /** WORK_SPACE_NAME */
    private String workspace = null;

    public String getWorkspace() {
        return workspace;
    }

    public void setWorkspace(String workspace) {
        this.workspace = workspace;
    }
    /** repositoryService */
    private RepositoryService repositoryService;
    /** repository */
    private ManageableRepository repository;
    /** session */
    SessionProvider sp;
    private Session session;
    public static int c = 0;

    public JcrProcessor() {
        ExoContainer container = ExoContainerContext.getContainerByName("portal");
        repositoryService = (RepositoryService) container.getComponentInstanceOfType(RepositoryService.class);
        SessionProviderService sessionProviderService = (SessionProviderService) container.getComponentInstanceOfType(SessionProviderService.class);
        sp = sessionProviderService.getSystemSessionProvider(null);
        try {
            repository = repositoryService.getDefaultRepository();
        } catch (RepositoryException ex) {
            Logger.getLogger(JcrProcessor.class.getName()).log(Level.SEVERE, null, ex);
        } catch (RepositoryConfigurationException ex) {
            Logger.getLogger(JcrProcessor.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public String connectRepository(String workspace) throws RepositoryConfigurationException, RepositoryException {
        c = 0;

        if (workspace == null) {
            workspace = repository.getConfiguration().getDefaultWorkspaceName();
        }

        if (workspace.equals(this.workspace)) {
            return this.workspace;
        }

        this.workspace = workspace;
        session = sp.getSession(workspace, repository);
        //session = repository.login(null, workspace);
        return workspace;
    }

    public Node getRootNode() throws RepositoryException, RepositoryConfigurationException {
        return session.getRootNode();
    }

    public void accessNNodes(Node n, int i) throws RepositoryException {
        NodeIterator ni = n.getNodes();

        while (ni.hasNext()) {
            c++;
            Node nextNode = (Node) ni.next();
            log.debug("Accessing node in: " + nextNode.getPath());
            accessNNodes(nextNode, i);
            if (c > i) {
                break;
            }
        }
    }

    public void addRandomNode(Node destination) throws LoginException, NoSuchWorkspaceException, RepositoryException {
        c++;
        StringBuilder sb = new StringBuilder();
        sb.append("node").append((new Date()).getTime()).append((int) (Math.random() * 10000));
        destination.addNode(sb.toString());
        log.debug("adding node: "+sb.toString());
        destination.save();
        session.save();
    }
}
